![jod tiny cube](jodtinycube.png) [`jod` README](http://bakerjd99.wordpress.com/the-jod-page/)
=============================================================================================

This repository contains distributed [J language](http://www.jsoftware.com/) 
[JOD addon](http://www.jsoftware.com/jwiki/Addons/general/jod) source code.
More information about JOD is available on [The JOD Page](http://bakerjd99.wordpress.com/the-jod-page/).

The directories [`jod`](https://github.com/bakerjd99/jod/tree/master/jod) and
[`jodsource`](https://github.com/bakerjd99/jod/tree/master/jodsource) contain
the J addon code distributed by [Pacman](https://code.jsoftware.com/wiki/Pacman) in the
[`jod`](http://www.jsoftware.com/jwiki/Addons/general/jod) and
[`jodsource`](http://www.jsoftware.com/jwiki/Addons/general/jodsource) addons.

You can get a "taste" of JOD by browsing the Jupyter notebooks.

1. [JOD Introduction Lab](https://github.com/bakerjd99/jod/blob/master/jodnotebooks/JOD%20Introduction%20Lab.ipynb) [(PDF version)](https://github.com/bakerjd99/jod/blob/master/jodnotebooks/JODIntroductionLab.pdf)
2. [JOD Source Code Dump Scripts Lab](https://github.com/bakerjd99/jod/blob/master/jodnotebooks/JOD%20Source%20Code%20Dump%20Scripts%20Lab.ipynb) [(PDF version)](https://github.com/bakerjd99/jod/blob/master/jodnotebooks/JODSourceCodeDumpScriptsLab.pdf)
3. [JOD Best Practices Lab](https://github.com/bakerjd99/jod/blob/master/jodnotebooks/JOD%20Best%20Practices%20Lab.ipynb) [(PDF version)](https://github.com/bakerjd99/jod/blob/master/jodnotebooks/JODBestPracticesLab.pdf)
4. [Using JOD Regular Expressions](https://github.com/bakerjd99/jod/blob/master/jodnotebooks/Using%20JOD%20Regular%20Expressions.ipynb) [(PDF version)](https://github.com/bakerjd99/jod/blob/master/jodnotebooks/UsingJODRegularExpressions.pdf)
5. [Using JOD Backup Get](https://github.com/bakerjd99/jod/blob/master/jodnotebooks/Using%20JOD%20Backup%20Get.ipynb) [(PDF version)](https://github.com/bakerjd99/jod/blob/master/jodnotebooks/UsingJODBackupGet.pdf)
6. [Building JOD Addons](https://github.com/bakerjd99/jod/blob/master/jodnotebooks/Building%20JOD%20Addons.ipynb) [(PDF version)](https://github.com/bakerjd99/jod/blob/master/jodnotebooks/BuildingJODAddons.pdf)
7. [Using jodliterate](https://github.com/bakerjd99/jacks/blob/master/jodliterate/Using%20jodliterate.ipynb) [(PDF version)](https://github.com/bakerjd99/jacks/blob/master/jodliterate/UsingJodliterate.pdf)

JOD addon code is "compressed": whitespace and comments have been removed
and *safe local identifiers* have been reduced to single characters. Compression
significantly reduces the size of code at the expense of *readability.* To
make casual browsing of JOD code easy, *without building JOD dictionaries*, the 
directory [`jodijs`](https://github.com/bakerjd99/jod/tree/master/jodijs) contains
fully commented JOD source. `jodijs` is not distributed by [Pacman](https://code.jsoftware.com/wiki/Pacman).

John Baker
November 15, 2020
